/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package at.fhooe.mc.magicwand.client.sensors;

import javax.microedition.io.*;
import java.io.*;

/**
 *
 * @author Manu
 */
public class CompassSocket {

    private SocketConnection m_con;
    private DataOutputStream m_dos;
    private DataInputStream m_dis;
    public String m_angle;
    public String m_requestString;
    public String m_closeString;
    public String m_serverAck;

    public CompassSocket(int _port) {
        try {
            m_requestString = "get";
            m_closeString = "byebye";
            m_serverAck = "ok";
            m_con = (SocketConnection) Connector.open("socket://127.0.0.1:" + _port);
            if (!waitForAck()){
                //inform user (exception)
            }
        } catch (Exception _e) {
            _e.printStackTrace();
        }

    }

    public void sendRequest() {
        try {
            sendMessage(m_requestString);
            waitForAnswer();
        } catch (Exception _e) {
            _e.printStackTrace();
        }
    }

    public void close() {
        try {
            sendMessage(m_closeString);
            if (waitForAck()) {
                m_dos.close();
                m_dis.close();
                m_con.close();
            }

        } catch (Exception _e) {
            _e.printStackTrace();
        }
    }

    private void sendMessage(String _message) {
        try {
            if (m_dos == null) {
                m_dos = m_con.openDataOutputStream();
            }
            m_dos.writeUTF(_message);
            m_dos.flush();
        } catch (Exception _e) {
            _e.printStackTrace();
        }
    }

    private void waitForAnswer() {
        try {
            String answer = receiveAnswer();
            if (answer != null) {
                m_angle = answer.toString();
            } else {
                m_angle = "-1";
            }
        } catch (Exception _e) {
            _e.printStackTrace();
        }
    }

    private boolean waitForAck() {
        try {
            String answer = receiveAnswer();
            if (answer != null)
                return answer.toString().equals(m_serverAck);
            else
                return false;
        } catch (Exception _e) {
            //ack not received exception
            return false;
        }
    }

    private String receiveAnswer() {
        try {
            if (m_dis == null) {
                m_dis = m_con.openDataInputStream();
            }

            int inputChar;
            StringBuffer answer = new StringBuffer();
            while ((inputChar = m_dis.read()) != (int) '\0') {
                answer.append((char) inputChar);
            }
            return answer.toString();
        } catch (Exception _e) {
            //ack not received exception
            return null;
        }
    }
}
